<?php

use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Schema;

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateUsersTable extends Migration
{
	/**
	* Run the migrations.
	*
	* @return void
	*/
	public function up()
	{
		Schema::create('users', function (Blueprint $table) {
			$table->increments('id');
			$table->string('username')->unique();
			$table->string('email')->unique();
			$table->string('emailEncoded')->unique();
			$table->string('password');
			$table->string('avatar')->nullable();
			$table->string('description')->nullable();
			$table->rememberToken();
			$table->timestamps();
		});
		// Insert reserved usernames

		$reservedUsernames = array(
				"0",
				"about",
				"access",
				"account",
				"accounts",
				"activate",
				"activities",
				"activity",
				"ad",
				"add",
				"address",
				"adm",
				"admin",
				"administration",
				"administrator",
				"ads",
				"advertising",
				"affiliate",
				"affiliates",
				"all",
				"analysis",
				"analytics",
				"anon",
				"anonymous",
				"api",
				"app",
				"apps",
				"archive",
				"archives",
				"asset",
				"auth",
				"authentication",
				"avatar",
				"backup",
				"beta",
				"billing",
				"bin",
				"blog",
				"blogs",
				"board",
				"bot",
				"bots",
				"bug",
				"bugs",
				"cache",
				"call",
				"cancel",
				"captcha",
				"career",
				"careers",
				"cart",
				"categories",
				"category",
				"cgi",
				"cgi-bin",
				"changelog",
				"chat",
				"check",
				"checking",
				"checkout",
				"client",
				"clients",
				"code",
				"comment",
				"comments",
				"communities",
				"community",
				"company",
				"config",
				"configuration",
				"connect",
				"contact",
				"contact-us",
				"contact_us",
				"contactus",
				"contribute",
				"corp",
				"create",
				"css",
				"dashboard",
				"data",
				"db",
				"default",
				"delete",
				"demo",
				"destroy",
				"dev",
				"devel",
				"developer",
				"developers",
				"die",
				"dir",
				"directory",
				"dist",
				"doc",
				"docs",
				"documentation",
				"download",
				"downloads",
				"edit",
				"editor",
				"email",
				"employment",
				"empty",
				"end",
				"enterprise",
				"entries",
				"entry",
				"error",
				"errors",
				"eval",
				"event",
				"exit",
				"explore",
				"faq",
				"favorite",
				"favorites",
				"feature",
				"features",
				"feed",
				"feedback",
				"feeds",
				"file",
				"files",
				"first",
				"follow",
				"followers",
				"following",
				"forgot",
				"forgot-password",
				"forgot_password",
				"forgotpassword",
				"form",
				"forum",
				"forums",
				"free",
				"friend",
				"friends",
				"ftp",
				"get",
				"gift",
				"gifts",
				"gist",
				"graph",
				"group",
				"groups",
				"guest",
				"guests",
				"help",
				"home",
				"homepage",
				"host",
				"hosting",
				"hostmaster",
				"hostname",
				"howto",
				"html",
				"http",
				"httpd",
				"https",
				"i",
				"id",
				"image",
				"images",
				"imap",
				"img",
				"index",
				"info",
				"information",
				"inquiry",
				"intranet",
				"invitations",
				"invite",
				"irc",
				"is",
				"issue",
				"issues",
				"it",
				"item",
				"items",
				"java",
				"javascript",
				"job",
				"jobs",
				"join",
				"js",
				"json",
				"knowledgebase",
				"language",
				"languages",
				"last",
				"legal",
				"license",
				"link",
				"links",
				"list",
				"lists",
				"log",
				"log-in",
				"log-out",
				"log_in",
				"log_out",
				"login",
				"logout",
				"logs",
				"m",
				"mail",
				"mail1",
				"mail2",
				"mail3",
				"mail4",
				"mail5",
				"mailer",
				"mailing",
				"maintenance",
				"manager",
				"manual",
				"map",
				"maps",
				"marketing",
				"master",
				"me",
				"media",
				"member",
				"members",
				"message",
				"messages",
				"mob",
				"mobile",
				"movie",
				"movies",
				"msg",
				"music",
				"mx",
				"my",
				"name",
				"names",
				"named",
				"namespace",
				"namespaces",
				"nan",
				"navi",
				"navigation",
				"net",
				"network",
				"new",
				"news",
				"newsletter",
				"nick",
				"nickname",
				"notes",
				"notification",
				"notifications",
				"notify",
				"ns",
				"ns1",
				"ns10",
				"ns2",
				"ns3",
				"ns4",
				"ns5",
				"ns6",
				"ns7",
				"ns8",
				"ns9",
				"null",
				"oauth",
				"offer",
				"offers",
				"official",
				"old",
				"online",
				"openid",
				"operator",
				"order",
				"orders",
				"organization",
				"organizations",
				"orgs",
				"overview",
				"owner",
				"owners",
				"page",
				"pages",
				"panel",
				"password",
				"payment",
				"photo",
				"photos",
				"pic",
				"pics",
				"ping",
				"plan",
				"plans",
				"plugin",
				"plugins",
				"policy",
				"pop",
				"pop3",
				"popular",
				"portal",
				"post",
				"postmaster",
				"posts",
				"pr",
				"premium",
				"press",
				"price",
				"pricing",
				"privacy",
				"privacy-policy",
				"privacy_policy",
				"privacypolicy",
				"private",
				"product",
				"products",
				"profile",
				"project",
				"projects",
				"promo",
				"pub",
				"public",
				"put",
				"query",
				"random",
				"ranking",
				"read",
				"readme",
				"recent",
				"recruit",
				"recruitment",
				"register",
				"registration",
				"release",
				"releases",
				"remove",
				"reply",
				"replies",
				"report",
				"reports",
				"repositories",
				"repository",
				"req",
				"request",
				"requests",
				"res",
				"reset",
				"reset-password",
				"reset_password",
				"resetpassword",
				"resource",
				"resources",
				"root",
				"rss",
				"rule",
				"rules",
				"sale",
				"sales",
				"sample",
				"samples",
				"save",
				"script",
				"scripts",
				"search",
				"secure",
				"security",
				"self",
				"send",
				"server",
				"server-info",
				"server-status",
				"service",
				"services",
				"session",
				"sessions",
				"setting",
				"settings",
				"setup",
				"share",
				"shop",
				"show",
				"sign-in",
				"sign-up",
				"sign_in",
				"sign_up",
				"signin",
				"signout",
				"signup",
				"site",
				"sitemap",
				"sites",
				"smtp",
				"source",
				"spec",
				"special",
				"src",
				"ssh",
				"ssl",
				"ssladmin",
				"ssladministrator",
				"sslwebmaster",
				"staff",
				"stage",
				"staging",
				"start",
				"stat",
				"state",
				"static",
				"stats",
				"status",
				"store",
				"stores",
				"stories",
				"style",
				"styles",
				"stylesheet",
				"stylesheets",
				"subdomain",
				"subscribe",
				"subscriptions",
				"support",
				"sys",
				"sysadmin",
				"sysadministrator",
				"system",
				"tag",
				"tags",
				"talk",
				"task",
				"tasks",
				"team",
				"teams",
				"tech",
				"telnet",
				"term",
				"terms",
				"terms-of-service",
				"terms_of_service",
				"termsofservice",
				"test",
				"test1",
				"test2",
				"test3",
				"testing",
				"tests",
				"theme",
				"themes",
				"thread",
				"threads",
				"tmp",
				"todo",
				"tool",
				"tools",
				"top",
				"topic",
				"topics",
				"tos",
				"tour",
				"translations",
				"trends",
				"tutorial",
				"undef",
				"unfollow",
				"unsubscribe",
				"update",
				"upload",
				"uploads",
				"url",
				"usage",
				"user",
				"username",
				"users",
				"ver",
				"version",
				"video",
				"videos",
				"visitor",
				"watch",
				"web",
				"webmail",
				"webmaster",
				"website",
				"websites",
				"welcome",
				"widget",
				"widgets",
				"wiki",
				"work",
				"works",
				"ww",
				"wws",
				"www",
				"www1",
				"www2",
				"www3",
				"www4",
				"www5",
				"www6",
				"www7",
				"wwws",
				"wwww",
				"xfn",
				"xml",
				"xmpp",
				"xpg",
				"xxx",
				"yaml",
				"year",
				"yml",
				"you",
				"yourdomain",
				"yourname",
				"yoursite",
				"yourusername"
		);

		// $sqlString = array();

		// foreach( $reservedUsernames as $reserved ) {
		// 	array_push(
		// 		$sqlString,
		// 		array(
		// 			'username' => $reserved,
		// 			'email' => $reserved .'@curiouz.com',
		// 			'emailEncoded' => Hash::make($reserved .'curiouz.com'),
		// 			'password' => $reserved
		// 		)
		// 	);
		// }

	}

	/**
	* Reverse the migrations.
	*
	* @return void
	*/
	public function down()
	{
		Schema::dropIfExists('users');
	}
}
